Index: django/db/backends/postgresql_psycopg2/introspection.py
===================================================================
--- django/db/backends/postgresql_psycopg2/introspection.py	(revision 17914)
+++ django/db/backends/postgresql_psycopg2/introspection.py	(working copy)
@@ -1,3 +1,4 @@
+from django.db import QName
 from django.db.backends import BaseDatabaseIntrospection
 
 
@@ -21,50 +22,111 @@
         1266: 'TimeField',
         1700: 'DecimalField',
     }
+
+    def get_schema_list(self, cursor):
+        cursor.execute("""
+            SELECT n.nspname
+            FROM pg_catalog.pg_namespace n
+            WHERE n.nspname != 'information_schema' AND n.nspname not like 'pg_%%'""")
+        return [row[0] for row in cursor.fetchall()]
         
-    def get_table_list(self, cursor):
-        "Returns a list of table names in the current database."
+    def get_visible_tables_list(self, cursor):
+        """
+        Returns a list of all by-default visible table names in the current
+        database.
+        """
+        sql = """
+            SELECT n.nspname, c.relname
+            FROM pg_catalog.pg_class c
+            LEFT JOIN pg_catalog.pg_namespace n ON n.oid = c.relnamespace
+            WHERE c.relkind IN ('r', 'v', '')
+                AND n.nspname NOT IN ('pg_catalog', 'pg_toast')
+                AND (pg_catalog.pg_table_is_visible(c.oid)"""
+        # We must add the default schema to always visible schemas to make
+        # things work nicely.
+        if self.connection.schema:
+            sql += " OR n.nspname = %s)"
+            cursor.execute(sql, (self.connection.schema,))
+        else:
+            cursor.execute(sql + ')')
+        return [QName(row[0], row[1], True) for row in cursor.fetchall()]
+    
+    def get_qualified_tables_list(self, cursor, schemas):
+        """
+        Returns schema qualified names of all tables in the current database.
+        """
+        if not schemas:
+            return []
         cursor.execute("""
-            SELECT c.relname
+            SELECT n.nspname, c.relname
             FROM pg_catalog.pg_class c
             LEFT JOIN pg_catalog.pg_namespace n ON n.oid = c.relnamespace
             WHERE c.relkind IN ('r', 'v', '')
-                AND n.nspname NOT IN ('pg_catalog', 'pg_toast')
-                AND pg_catalog.pg_table_is_visible(c.oid)""")
-        return [row[0] for row in cursor.fetchall()]
+                AND n.nspname IN %s""", (tuple(schemas),))
+        return [QName(row[0], row[1], True) for row in cursor.fetchall()]
 
-    def get_table_description(self, cursor, table_name):
+    def get_table_description(self, cursor, qname):
         "Returns a description of the table, with the DB-API cursor.description interface."
         # As cursor.description does not return reliably the nullable property,
         # we have to query the information_schema (#7783)
-        cursor.execute("""
-            SELECT column_name, is_nullable
-            FROM information_schema.columns
-            WHERE table_name = %s""", [table_name])
+        qname = self.qname_converter(qname)
+        if not qname.schema:
+            cursor.execute("""
+                SELECT column_name, is_nullable
+                FROM information_schema.columns
+                WHERE table_name = %s""",
+                [qname.table])
+        else:
+            cursor.execute("""
+                SELECT column_name, is_nullable
+                FROM information_schema.columns
+                WHERE table_schema = %s and table_name = %s""",
+                [qname.schema, qname.table])
         null_map = dict(cursor.fetchall())
-        cursor.execute("SELECT * FROM %s LIMIT 1" % self.connection.ops.quote_name(table_name))
+        cursor.execute(
+            "SELECT * FROM %s LIMIT 1" % self.connection.ops.qualified_name(qname))
         return [tuple([item for item in line[:6]] + [null_map[line[0]]==u'YES'])
-            for line in cursor.description]
+                for line in cursor.description]
 
-    def get_relations(self, cursor, table_name):
+    def get_relations(self, cursor, qname):
         """
         Returns a dictionary of {field_index: (field_index_other_table, other_table)}
-        representing all relationships to the given table. Indexes are 0-based.
+        representing all relationships to the given table. Indexes are 0-based. The
+        other_table will be in qualified format.
         """
-        cursor.execute("""
-            SELECT con.conkey, con.confkey, c2.relname
-            FROM pg_constraint con, pg_class c1, pg_class c2
-            WHERE c1.oid = con.conrelid
-                AND c2.oid = con.confrelid
-                AND c1.relname = %s
-                AND con.contype = 'f'""", [table_name])
+        qname = self.qname_converter(qname)
+        if not qname.schema:
+            cursor.execute("""
+                SELECT con.conkey, con.confkey, nsp2.nspname, c2.relname
+                FROM pg_constraint con, pg_class c1, pg_class c2,
+                     pg_namespace nsp2
+                WHERE c1.oid = con.conrelid
+                    AND c2.oid = con.confrelid
+                    AND nsp2.oid = c2.relnamespace
+                    AND c1.relname = %s
+                    AND con.contype = 'f'""",
+                [qname.table])
+        else:
+            cursor.execute("""
+                SELECT con.conkey, con.confkey, nsp2.nspname, c2.relname
+                FROM pg_constraint con, pg_class c1, pg_class c2,
+                     pg_namespace nsp1, pg_namespace nsp2
+                WHERE c1.oid = con.conrelid
+                    AND nsp1.oid = c1.relnamespace
+                    AND c2.oid = con.confrelid
+                    AND nsp2.oid = c2.relnamespace
+                    AND nsp1.nspname = %s
+                    AND c1.relname = %s
+                    AND con.contype = 'f'""",
+                [qname.schema, qname.table])
         relations = {}
         for row in cursor.fetchall():
             # row[0] and row[1] are single-item lists, so grab the single item.
-            relations[row[0][0] - 1] = (row[1][0] - 1, row[2])
+            relations[row[0][0] - 1] = (row[1][0] - 1,
+                                        QName(row[2], row[3], True))
         return relations
 
-    def get_indexes(self, cursor, table_name):
+    def get_indexes(self, cursor, qname):
         """
         Returns a dictionary of fieldname -> infodict for the given table,
         where each infodict is in the format:
@@ -73,15 +135,31 @@
         """
         # This query retrieves each index on the given table, including the
         # first associated field name
-        cursor.execute("""
-            SELECT attr.attname, idx.indkey, idx.indisunique, idx.indisprimary
-            FROM pg_catalog.pg_class c, pg_catalog.pg_class c2,
-                pg_catalog.pg_index idx, pg_catalog.pg_attribute attr
-            WHERE c.oid = idx.indrelid
-                AND idx.indexrelid = c2.oid
-                AND attr.attrelid = c.oid
-                AND attr.attnum = idx.indkey[0]
-                AND c.relname = %s""", [table_name])
+        qname = self.qname_converter(qname)
+        if not qname.schema:
+            cursor.execute("""
+                SELECT attr.attname, idx.indkey, idx.indisunique, idx.indisprimary
+                FROM pg_catalog.pg_class c, pg_catalog.pg_class c2,
+                    pg_catalog.pg_index idx, pg_catalog.pg_attribute attr
+                WHERE c.oid = idx.indrelid
+                    AND idx.indexrelid = c2.oid
+                    AND attr.attrelid = c.oid
+                    AND attr.attnum = idx.indkey[0]
+                    AND c.relname = %s""",
+                [qname.table])
+        else:
+            cursor.execute("""
+                SELECT attr.attname, idx.indkey, idx.indisunique, idx.indisprimary
+                FROM pg_catalog.pg_class c, pg_catalog.pg_namespace nsp,
+                    pg_catalog.pg_class c2, pg_catalog.pg_index idx,
+                    pg_catalog.pg_attribute attr
+                WHERE c.oid = idx.indrelid
+                    AND nsp.oid = c.relnamespace
+                    AND idx.indexrelid = c2.oid
+                    AND attr.attrelid = c.oid
+                    AND attr.attnum = idx.indkey[0]
+                    AND nsp.nspname = %s AND c.relname = %s""",
+                [qname.schema, qname.table])
         indexes = {}
         for row in cursor.fetchall():
             # row[1] (idx.indkey) is stored in the DB as an array. It comes out as
@@ -92,3 +170,15 @@
                 continue
             indexes[row[0]] = {'primary_key': row[3], 'unique': row[2]}
         return indexes
+
+    def qname_converter(self, qname, force_schema=False):
+        """
+        On postgresql it is impossible to force usage of schema - 
+        we do not know what the default schema is. In fact, there can be
+        multiple schemas.
+        """
+        assert isinstance(qname, QName)
+        if qname.db_format:
+            return qname
+        return QName((qname.schema or self.connection.schema), qname.table,
+                     True)
Index: django/db/backends/postgresql_psycopg2/operations.py
===================================================================
--- django/db/backends/postgresql_psycopg2/operations.py	(revision 17914)
+++ django/db/backends/postgresql_psycopg2/operations.py	(working copy)
@@ -1,3 +1,4 @@
+from django.db import QName
 from django.db.backends import BaseDatabaseOperations
 
 
@@ -56,11 +57,11 @@
             return 'HOST(%s)'
         return '%s'
 
-    def last_insert_id(self, cursor, table_name, pk_name):
+    def last_insert_id(self, cursor, qualified_name, pk_name):
         # Use pg_get_serial_sequence to get the underlying sequence name
         # from the table name and column name (available since PostgreSQL 8)
         cursor.execute("SELECT CURRVAL(pg_get_serial_sequence('%s','%s'))" % (
-            self.quote_name(table_name), pk_name))
+            self.qualified_name(qualified_name), pk_name))
         return cursor.fetchone()[0]
 
     def no_limit_value(self):
@@ -71,6 +72,25 @@
             return name # Quoting once is enough.
         return '"%s"' % name
 
+    def qualified_name(self, qname):
+        """
+        Return the table's name in fully qualified format
+        (schema_name.tbl_name) if there is a schema_name, else returns just
+        the tbl_name in quoted format.
+
+        convert_name has no effect on PostgreSQL, as there is no need
+        to do anything else than quoting for the name even in testing.
+        """
+        assert isinstance(qname, QName)
+        schema = qname.schema
+        if not qname.db_format and not schema:
+            schema = self.connection.schema
+        if schema:
+            return "%s.%s" % (self.quote_name(schema),
+                              self.quote_name(qname.table))
+        else:
+            return self.quote_name(qname.table)
+
     def set_time_zone_sql(self):
         return "SET TIME ZONE %s"
 
@@ -81,13 +101,15 @@
             # table.
             sql = ['%s %s;' % \
                 (style.SQL_KEYWORD('TRUNCATE'),
-                    style.SQL_FIELD(', '.join([self.quote_name(table) for table in tables]))
+                    style.SQL_FIELD(', '.join([self.qualified_name(table)
+                                               for table in tables]))
             )]
 
             # 'ALTER SEQUENCE sequence_name RESTART WITH 1;'... style SQL statements
             # to reset sequence indices
             for sequence_info in sequences:
-                table_name = sequence_info['table']
+                qname = sequence_info['qname']
+                qualified_name = self.qualified_name(qname)
                 column_name = sequence_info['column']
                 if not (column_name and len(column_name) > 0):
                     # This will be the case if it's an m2m using an autogenerated
@@ -95,7 +117,7 @@
                     column_name = 'id'
                 sql.append("%s setval(pg_get_serial_sequence('%s','%s'), 1, false);" % \
                     (style.SQL_KEYWORD('SELECT'),
-                    style.SQL_TABLE(self.quote_name(table_name)),
+                    style.SQL_TABLE(qualified_name),
                     style.SQL_FIELD(column_name))
                 )
             return sql
@@ -121,27 +143,29 @@
 
             for f in model._meta.local_fields:
                 if isinstance(f, models.AutoField):
+                    qualified_name = self.qualified_name(model._meta.qualified_name)
                     output.append("%s setval(pg_get_serial_sequence('%s','%s'), coalesce(max(%s), 1), max(%s) %s null) %s %s;" % \
                         (style.SQL_KEYWORD('SELECT'),
-                        style.SQL_TABLE(qn(model._meta.db_table)),
+                        style.SQL_TABLE(qualified_name),
                         style.SQL_FIELD(f.column),
                         style.SQL_FIELD(qn(f.column)),
                         style.SQL_FIELD(qn(f.column)),
                         style.SQL_KEYWORD('IS NOT'),
                         style.SQL_KEYWORD('FROM'),
-                        style.SQL_TABLE(qn(model._meta.db_table))))
+                        style.SQL_TABLE(qualified_name)))
                     break # Only one AutoField is allowed per model, so don't bother continuing.
             for f in model._meta.many_to_many:
                 if not f.rel.through:
+                    qualified_name = self.qualified_name(f.m2m_qualified_name())
                     output.append("%s setval(pg_get_serial_sequence('%s','%s'), coalesce(max(%s), 1), max(%s) %s null) %s %s;" % \
                         (style.SQL_KEYWORD('SELECT'),
-                        style.SQL_TABLE(qn(f.m2m_db_table())),
+                        style.SQL_TABLE(qualified_name),
                         style.SQL_FIELD('id'),
                         style.SQL_FIELD(qn('id')),
                         style.SQL_FIELD(qn('id')),
                         style.SQL_KEYWORD('IS NOT'),
                         style.SQL_KEYWORD('FROM'),
-                        style.SQL_TABLE(qn(f.m2m_db_table()))))
+                        style.SQL_TABLE(qualified_name)))
         return output
 
     def savepoint_create_sql(self, sid):
Index: django/db/backends/postgresql_psycopg2/creation.py
===================================================================
--- django/db/backends/postgresql_psycopg2/creation.py	(revision 17914)
+++ django/db/backends/postgresql_psycopg2/creation.py	(working copy)
@@ -43,7 +43,9 @@
     def sql_indexes_for_field(self, model, f, style):
         if f.db_index and not f.unique:
             qn = self.connection.ops.quote_name
-            db_table = model._meta.db_table
+            qn3 = self.connection.ops.qualified_name
+            qualified_name = model._meta.qualified_name
+            db_table = qualified_name[1]
             tablespace = f.db_tablespace or model._meta.db_tablespace
             if tablespace:
                 tablespace_sql = self.connection.ops.tablespace_sql(tablespace)
@@ -56,7 +58,7 @@
                 return (style.SQL_KEYWORD('CREATE INDEX') + ' ' +
                         style.SQL_TABLE(qn(truncate_name(index_name,self.connection.ops.max_name_length()))) + ' ' +
                         style.SQL_KEYWORD('ON') + ' ' +
-                        style.SQL_TABLE(qn(db_table)) + ' ' +
+                        style.SQL_TABLE(qn3(qualified_name)) + ' ' +
                         "(%s%s)" % (style.SQL_FIELD(qn(f.column)), opclass) +
                         "%s;" % tablespace_sql)
 
@@ -85,3 +87,7 @@
         self.connection.connection.rollback()
         self.connection.connection.set_isolation_level(
                 psycopg2.extensions.ISOLATION_LEVEL_AUTOCOMMIT)
+
+    def sql_destroy_schema(self, schema, style):
+        qn = self.connection.ops.quote_name
+        return "%s %s CASCADE;" % (style.SQL_KEYWORD('DROP SCHEMA'), qn(schema))
Index: django/db/backends/postgresql_psycopg2/base.py
===================================================================
--- django/db/backends/postgresql_psycopg2/base.py	(revision 17914)
+++ django/db/backends/postgresql_psycopg2/base.py	(working copy)
@@ -83,6 +83,7 @@
     has_bulk_insert = True
     supports_tablespaces = True
     can_distinct_on_fields = True
+    namespaced_schemas = True
 
 class DatabaseWrapper(BaseDatabaseWrapper):
     vendor = 'postgresql'
@@ -121,6 +122,10 @@
         self.validation = BaseDatabaseValidation(self)
         self._pg_version = None
 
+    def _get_test_schema_prefix(self):
+        return ''
+    test_schema_prefix = property(_get_test_schema_prefix)
+
     def check_constraints(self, table_names=None):
         """
         To check constraints, we set constraints to immediate. Then, when, we're done we must ensure they
